import greenfoot.*;
import java.util.List;

public class Koerper extends Actor
{    
    int zeit = 8;
    int magazin = 31;
    int nachladezeit = 60;
    boolean zustand=false;
    int block = 0;
    int leben = 100;
    
    //Bilder des Spielers
    private GreenfootImage bild1;
    private GreenfootImage bild2;
    private GreenfootImage bild3;
    private GreenfootImage bild4;
    
    //Variablen fr die "Physik" des Spiels
    private int speed = 7;
    private int vSpeed = 0;
    private int acceleration = 1;
    private int jumpStrength = 15;
    private boolean jumping = false;
    private int floor;
    private int reduceCollisionDetection = 3;
    private int currCollDetection = 0;
    public void act() 
    {
        dieBewegung();
        fallUeberpruefen();
        checkBeine();
        
        //Bilder werden Variablen zugewiesen
        bild1 = new GreenfootImage("spieler_obenc.png");
        bild2 = new GreenfootImage("spieler_oben2c.png");
        bild3 = new GreenfootImage("spieler_oben3c.png");
        bild4 = new GreenfootImage("spieler_oben4c.png");
    }
    
    public void dieBewegung()
    {
        if(block == 0) //Spieler bewegt sich nicht horizonal durch "Boden"-Klassen
        {
            if (Greenfoot.isKeyDown("a") ) //Bewegung nach links
            {
                if (!(checkLeft()) || vSpeed < 0)
                {
                    moveLeft();
                }
            }
            
            if (Greenfoot.isKeyDown("d") ) //Bewegung nach rechts
            {
                if (!(checkRight()) || vSpeed < 0)
                {
                    moveRight();
                }
            }
    
            if (Greenfoot.isKeyDown("space")&& jumping==false) //Springen
            {
                jump();
            }
            
            MouseInfo info = Greenfoot.getMouseInfo(); //X -und Y-Werte werden ermittelt
            if(info!=null) //Spieler guckt in die Richtung der Maus
            {
                int thatX=info.getX();
                int thatY=info.getY() ;
                turnTowards(thatX, thatY);
            }
            
            if(getRotation() >= 90 && getRotation() <= 270) //Bild der Oberkrpers wird zu einem auf dem Kopf stehendem gewechselt
            {
                setImage(bild2);
            }
            else
            {
                setImage(bild1);
            }
            
            if(Greenfoot.mousePressed(null)) //Solange die Maus gehalten wird, wird geschossen
            {
                zustand=true;
            }
            
            if(Greenfoot.mouseClicked(null)) //Solange die Maus gehalten wird, wird geschossen
            {
                zustand=false;
            }
            
            Kugel bt=new Kugel();
            bt.setRotation(getRotation()); //Rotation wird der, des Krpers angepasst
            if(zustand == true && magazin != 0) //Zustand blockiert das Schieen, wenn das Magazin leer ist
            {
                zeit--; //Counter
                if(zeit == 0) //Wenn der Counter bei null ist, wird ein Schuss abgegeben
                {
                    if(getRotation() <= 90 && getRotation() >= 0) //Die Kugel wird je nach Rotation versetzt (Perfektionismus)
                    {
                        setImage(bild3); //Kurz wird das Bild verndert (Waffe etwas nach Hinten versetzt)
                        getWorld().addObject(bt, getX()+11, getY()-13); //Das Versetzen
                        magazin = magazin - 1;
                        ((AmmoCounter)getWorld().getObjects(AmmoCounter.class).get(0)).bumpCount(-1); //Greift auf AmmoCounter.class zu, wird um 1 verringert
                        Greenfoot.playSound("shot.mp3");
                        zeit = 8; //Counter wird zurckgesetzt
                    }
                    else if(getRotation() >= 90 && getRotation() <= 180) //Die Kugel wird je nach Rotation versetzt (Perfektionismus)
                    {
                        setImage(bild4); //Kurz wird das Bild verndert (Waffe etwas nach Hinten versetzt)
                        getWorld().addObject(bt, getX()-11, getY()-13); //Das Versetzen 
                        magazin = magazin - 1;
                        ((AmmoCounter)getWorld().getObjects(AmmoCounter.class).get(0)).bumpCount(-1); //Greift auf AmmoCounter.class zu, wird um 1 verringert
                        Greenfoot.playSound("shot.mp3");
                        zeit = 8; //Counter wird zurckgesetzt
                    }
                    else if(getRotation() >= 180 && getRotation() <= 270) //Die Kugel wird je nach Rotation versetzt (Perfektionismus)
                    {
                        setImage(bild4); //Kurz wird das Bild verndert (Waffe etwas nach Hinten versetzt)
                        getWorld().addObject(bt, getX()+11, getY()-13); //Das Versetzen
                        magazin = magazin - 1;
                        ((AmmoCounter)getWorld().getObjects(AmmoCounter.class).get(0)).bumpCount(-1); //Greift auf AmmoCounter.class zu, wird um 1 verringert
                        Greenfoot.playSound("shot.mp3");
                        zeit = 8; //Counter wird zurckgesetzt
                    }
                    else //Die Kugel wird je nach Rotation versetzt (Perfektionismus)
                    {
                        setImage(bild3); //Kurz wird das Bild verndert (Waffe etwas nach Hinten versetzt)
                        getWorld().addObject(bt, getX()-11, getY()-13); //Das Versetzen
                        magazin = magazin - 1;
                        ((AmmoCounter)getWorld().getObjects(AmmoCounter.class).get(0)).bumpCount(-1); //Greift auf AmmoCounter.class zu, wird um 1 verringert
                        Greenfoot.playSound("shot.mp3");
                        zeit = 8; //Counter wird zurckgesetzt
                    }
                }
            }
       
            if(magazin == 0 || Greenfoot.isKeyDown("r")) //Nachladen des Magazins, dauert 60 Ticks
            {
                zustand = false;
                nachladezeit--;
                if(nachladezeit == 25) //Nachladegerusch der Waffe
                {
                    Greenfoot.playSound("reload.mp3");
                }             
                if(nachladezeit == 0) //Magazin und Counter werden resettet
                {
                    magazin = 31;
                    ((AmmoCounter)getWorld().getObjects(AmmoCounter.class).get(0)).bumpCount(31);
                    nachladezeit = 60;
                }
            }
        }
        else
        {}
    }
    
    public void fallUeberpruefen() //berprft ob der Spieler Boden unter den Fen hat
    {
        if(onGround()) {
            vSpeed = 0;
            jumping = false;
        }
        else {
            fall();
        }
    }
    
    public void fall() //Fall der Spielers (wird zunehmend schneller)
    {
        setLocation ( getX(), getY() + vSpeed);
        vSpeed = vSpeed + acceleration;
    }
    
    public boolean onGround() //Boolean zum berprfen ob der Spieler auf Boden steht
    {
        Boden under = null;
        int counter = 1;
        int max = vSpeed;
        while (counter <= max && under == null)
        {
            under = (Boden)getOneObjectAtOffset ( 0, getImage().getHeight() / 2 + counter, Boden.class);
            counter++;
        }
        return under != null;
    }
    
    public void moveRight() //Spieler bewegt sich nach rechts
    {
        if(block == 0)
        {
            setLocation ( getX() + speed, getY() );
        }
        else
        {}
    }

    public void moveLeft() //Spieler bewegt sich nach links
    {
        if(block == 0)
        {
            setLocation ( getX() - speed, getY() );
        }
        else
        {}
    }
    
    public void jump() //Spieler springt
    {
        jumping = true;
        vSpeed = -jumpStrength;
        fall();
    }
    
    public boolean checkLeft() //berprft ob links vom Spieler eine "Boden"-Klasse ist
    {
        Actor bumper = null;
        int counter = 0;
        int max = (int)(getImage().getHeight() / 2);
        while (counter < max && bumper == null)
        {
            bumper = getOneObjectAtOffset (-1*( getImage().getWidth() / 2), max - counter, Boden.class);
            counter++;
        }
        return bumper != null;
    }

    public boolean checkRight() //berprft ob rechts vom Spieler eine "Boden"-Klasse ist
    {
        Actor bumper = null;
        int counter = 0;
        int max = (int)(getImage().getHeight() / 2);
        while (counter < max && bumper == null)
        {
            bumper = getOneObjectAtOffset ( getImage().getWidth() / 2, max - counter , Boden.class);
            counter++;
        }
        return bumper != null;
    }
    
    public void checkBeine() //Es wird sichergestellt, dass sich der X-Wert vom Krper und den Beinen nicht verndert
    {
        int beineX = ((Beine) getWorld().getObjects(Beine.class).get(0)).getX();
        if(beineX < getX())
        {
            moveLeft();
        }
        else if(beineX > getX())
        {
            moveRight();
        }
    }
    
    public void getroffen()
    {
        if(leben > 0)
        {
            leben = leben - 1;
            ((HealthCounter)getWorld().getObjects(HealthCounter.class).get(0)).bumpCount(-1);
        }
        else if(leben == 0)
        {
            sterben();
        }
    }
    
    public void sterben()
    {
        List<GegnerMesser> enemys = getWorld().getObjects(GegnerMesser.class);
        if (enemys != null && !enemys.isEmpty()) //Gegner springen erfreut
        {  
            for (GegnerMesser enemy : enemys)
            {
                enemy.speed = 0;
                if(onGround() == true)
                {
                    enemy.jump();
                }
            }  
        }
        
        List<Gegner> spawn = getWorld().getObjects(Gegner.class); 
        if (spawn != null && !spawn.isEmpty()) //Keine weiteren Gegner werden gespawnt
        {  
            for (Gegner stop : spawn)
            {
                stop.spawnzeit = -1;
            }  
        }
        
        List<Koerper> spielertop = getWorld().getObjects(Koerper.class); //Krper wird bei Tot rotiert (liegen), man kann sich nicht mehr bewegen
        if (spielertop != null && !spielertop.isEmpty())
        {  
            for (Koerper stop : spielertop)
            {
                stop.block = 1;
                if(stop.getRotation() > 90 && stop.getRotation() < 270)
                {
                    stop.setRotation(91);
                }
                else
                {
                    stop.setRotation(270);
                }
            }  
        }
        
        List<Beine> spielerbot = getWorld().getObjects(Beine.class); //Beine werden bei Tot rotiert (liegen), man kann sich nicht mehr bewegen
        if (spielerbot != null && !spielerbot.isEmpty())
        {  
            for (Beine stop : spielerbot)
            {
                stop.block = 1;
                stop.setRotation(270);
            }  
        }
        
        ((Respawn)getWorld().getObjects(Respawn.class).get(0)).bumpCount(); //Text zum Respawnen erscheint
        if(Greenfoot.isKeyDown("e"))
        {
            Greenfoot.setWorld(new Welt()); //Welt wird resettet
        }
    }
}