import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

public class Kugel extends Actor
{
    public void act() 
    {
        move(40); //Geschwindigkeit der Kugel
        gegnerToeten();

        if(this != null && canSee(Boden.class) == true) //Wenn die "Boden"-Klasse oder der Rand der Welt erreicht wird verschwindet die Kugel
        {
            getWorld().removeObject(this);
        }
        else if(this != null && getX() >= getWorld().getWidth()-1 || getX() <= 0 || getY() >= getWorld().getHeight()-1 || getY() <= 0)
        {
            getWorld().removeObject(this);
        }
    }
    
    public boolean canSee(Class clss)
    {
        Actor actor = getOneObjectAtOffset(0, 0, clss);
        return actor != null;        
    }
    
    public void gegnerToeten() //Wenn die Kugel einen Gegner "sieht" tter er ihn
    {   
        GegnerMesser gegnermesser = (GegnerMesser) getOneObjectAtOffset(0, 0, GegnerMesser.class);  
        if (gegnermesser != null)
        {  
            gegnermesser.lebenVerlieren();  
        }  
    }
    
    public boolean onGround() //Prft, ob die Kugel den Boden berhrt
    {
        Actor on = getOneObjectAtOffset ( 0, getImage().getHeight()/2, Boden.class);
        return on!= null;
    }
}
