import greenfoot.*;
import java.util.Random;

public class Welt extends World
{
    GreenfootSound hintergrundMusik = new GreenfootSound("bgmusic.mp3");
    public Welt()
    {
        super(1280, 800, 1); //Gre des Spielfeldes
        
        hintergrundMusik.playLoop();
        hintergrundMusik.setVolume(70);
        if(Greenfoot.isKeyDown("r")) //Bei Reset des Spiels soll die Musik nicht doppelt abgespielt werden
        {
            hintergrundMusik.stop();
        }

        addObject(new AmmoCounter(),1120,40);
        addObject(new KillCounter(),1235,40);
        addObject(new HealthCounter(),1086,100);
        addObject(new Ammunition(),1053,40);
        addObject(new Leben(),1029,100);
        addObject(new Kills(),1190,40);
        addObject(new Respawn(),1120,150);
        
        addObject(new Beine(),457,484);
        addObject(new Koerper(),457,484);
        addObject(new GegnerMesser(),130,0);
        addObject(new Gegner(),1,1);
        
        //Boden ist ein 15x15 Pixel groes Objekt, wo der Spieler nicht durchfllt
        //Kleines Haus
        addObject(new Boden(),15,540);
        addObject(new Boden(),45,540);
        addObject(new Boden(),75,540);
        addObject(new Boden(),105,540);
        addObject(new Boden(),135,540);
        addObject(new Boden(),165,540);
        addObject(new Boden(),195,540);
        addObject(new Boden(),225,540);
        addObject(new Boden(),255,540);
        addObject(new Boden(),285,540);
        addObject(new Boden(),315,540);
        addObject(new Boden(),345,540);
        addObject(new Boden(),375,540);
        addObject(new Boden(),405,540);
        addObject(new Boden(),435,540);
        addObject(new Boden(),465,540);
        addObject(new Boden(),495,540);
        addObject(new Boden(),525,540);
        addObject(new Boden(),528,540);
        
        //Wand zweites Haus
        addObject(new Boden(),528,510);
        addObject(new Boden(),528,480);
        addObject(new Boden(),528,450);
        addObject(new Boden(),528,438);
        addObject(new Boden(),538,510);
        addObject(new Boden(),538,480);
        addObject(new Boden(),538,450);
        addObject(new Boden(),538,438);
        
        //Stahltrger
        addObject(new Boden(),15,336);
        addObject(new Boden(),45,336);
        addObject(new Boden(),75,336);
        addObject(new Boden(),105,336);
        addObject(new Boden(),135,336);
        addObject(new Boden(),165,336);
        addObject(new Boden(),195,336);
        addObject(new Boden(),225,336);
        addObject(new Boden(),255,336);
        addObject(new Boden(),285,336);
        addObject(new Boden(),315,336);
        addObject(new Boden(),345,336);
        addObject(new Boden(),375,336);
        addObject(new Boden(),400,336);
        
        //Groes Haus vor Tr
        addObject(new Boden(),540,438);
        addObject(new Boden(),570,438);
        addObject(new Boden(),600,438);
        addObject(new Boden(),630,438);
        addObject(new Boden(),660,438);
        addObject(new Boden(),690,438);
        addObject(new Boden(),720,438);
        addObject(new Boden(),750,438);
        addObject(new Boden(),780,438);
        
        //Tr
        addObject(new Boden(),780,408);
        addObject(new Boden(),780,378);
        addObject(new Boden(),780,348);
        addObject(new Boden(),780,346);
        addObject(new Boden(),790,408);
        addObject(new Boden(),790,378);
        addObject(new Boden(),790,348);
        addObject(new Boden(),790,346);
        addObject(new Boden(),810,346);
        addObject(new Boden(),820,346);
        addObject(new Boden(),850,376);
        addObject(new Boden(),880,406);
        addObject(new Boden(),910,436);
        
        //Haus nach Tr
        addObject(new Boden(),910,438);
        addObject(new Boden(),940,438);
        addObject(new Boden(),970,438);
        addObject(new Boden(),1000,438);
        addObject(new Boden(),1030,438);
        addObject(new Boden(),1060,438);
        addObject(new Boden(),1090,438);
        addObject(new Boden(),1120,438);
        addObject(new Boden(),1150,438);
        addObject(new Boden(),1180,438);
        addObject(new Boden(),1210,438);
        addObject(new Boden(),1240,438);
        addObject(new Boden(),1270,438);
        
        //Kran
        addObject(new Boden(),110,100);
        addObject(new Boden(),140,100);
        addObject(new Boden(),170,100);
        addObject(new Boden(),200,100);
        addObject(new Boden(),230,100);
        addObject(new Boden(),260,100);
        addObject(new Boden(),290,100);
        addObject(new Boden(),320,100);
        addObject(new Boden(),350,100);
        addObject(new Boden(),380,100);
        addObject(new Boden(),410,100);
        addObject(new Boden(),440,100);
        addObject(new Boden(),470,100);
        addObject(new Boden(),500,100);
        addObject(new Boden(),530,100);
        addObject(new Boden(),560,100);
        addObject(new Boden(),590,100);
        addObject(new Boden(),620,100);
        addObject(new Boden(),650,100);
        addObject(new Boden(),680,100);
        addObject(new Boden(),710,100);
        
        //Werbetafel
        addObject(new Boden(),977,195);
        addObject(new Boden(),1007,195);
        addObject(new Boden(),1037,195);
        addObject(new Boden(),1067,195);
        addObject(new Boden(),1097,195);
        addObject(new Boden(),1127,195);
        addObject(new Boden(),1157,195);
        addObject(new Boden(),1187,195);
        addObject(new Boden(),1217,195);
        addObject(new Boden(),1247,195);
        addObject(new Boden(),1277,195);
    }   
}